<?php

$plugin_info = array(
					 'pi_name'           => 'PurgeData',
					 'pi_version'        => '0.1',
					 'pi_author'         => 'Andrew Weaver',
					 'pi_author_url'     => 'http://www.brandnewbox.co.uk/docs/',
					 'pi_description'    => 'Clean up old weblog entries',
					 'pi_usage'          => PurgeData::usage()
					 );


class PurgeData {

	var $debug = false;

  var $weblog_id = '';
  var $days = '1';
  var $hours = '0';
    
  var $return_data = '';
    
  function PurgeData() {
	global $TMPL, $LOC, $FNS, $PREFS, $SESS, $REGX, $DB;
        
	// Check parameters
        
	$this->weblog_id = ( ! $TMPL->fetch_param('weblog') ) ? '' : $TMPL->fetch_param('weblog');
	$this->days = ( $TMPL->fetch_param('days') == "" ) ? $this->days : $TMPL->fetch_param('days');
	$this->hours = ( ! $TMPL->fetch_param('hours') ) ? $this->hours : $TMPL->fetch_param('hours');
	$this->debug = ( $TMPL->fetch_param('debug') ) ? true : false;
    
	if ($this->weblog_id == '') {
	  return $this->return_data;
	}
	
	$time_offset = $LOC->now - (( 60 * 60 * (24*$this->days) ) + ( 60 * 60 * $this->hours ));
	
	if ( $this->debug ) {
		print "Using weblog id = " . $this->weblog_id . ", Days = " . $this->days . ", Hours = " . $this->hours . "<br/>";
		print "Remove entries before " . date('l dS \of F Y h:i:s A', $time_offset);
		print " (" . $time_offset . ")<br/>";
	}
	
	$sql = "SELECT w.entry_id, w.title, w.entry_date FROM exp_weblog_titles w " .
         "WHERE w.weblog_id = " . $DB->escape_str( $this->weblog_id ) . " " . 
         "AND w.entry_date < " . $time_offset . " ORDER BY w.entry_date DESC";
	
	$query = $DB->query($sql);
	
	if ($query->num_rows == 0)
	{
			// No entries to delete
	}
	
	foreach ($query->result as $row)
	{
			if ( $this->debug) {
				print date('l dS \of F Y h:i:s A', $row['entry_date']) . " (" . $row['entry_date'] . "): " . $row["title"] . "<br/>";
			} else {
				$id = $row['entry_id'];
				$DB->query("DELETE FROM exp_weblog_titles WHERE entry_id = '$id'");
				$DB->query("DELETE FROM exp_weblog_data WHERE entry_id = '$id'");
				$DB->query("DELETE FROM exp_category_posts WHERE entry_id = '$id'");
				$DB->query("DELETE FROM exp_trackbacks WHERE entry_id = '$id'");
				$DB->query("DELETE FROM exp_comments WHERE entry_id = '$id'");
			}
	}
	
  }

  function usage() {
    ob_start(); 

	?>
Coming soon...
	
See: http://www.brandnewbox.co.uk/docs/
	<?php

	$buffer = ob_get_contents();	
    ob_end_clean(); 
    return $buffer;
  }

} // end class XMLGrab

?> 